(ns com.aurellem.gb.money
  (:use (com.aurellem.gb gb-driver util))
  (:import [com.aurellem.gb.gb_driver SaveState]))

(def money-address 0xD346)

(defn read-money
  "lol money is stored in BCD."
  ([^SaveState state]
     (Integer/parseInt 
      (apply str
             (map
              #(Integer/toHexString %)
              (subvec (vec (memory state)) money-address
                      (+ money-address 3)))) 10))
     ([] (read-money @current-state)))

(defn set-money
  ([^SaveState state new-money]
     (let [str-money (str new-money)]
       (assert (<= 0 (count str-money) 6))
       (set-memory-range
        state
        money-address
        (map #(Integer/parseInt % 16)
             (map (partial apply str)
                  (partition
                   2
                   (concat (repeat (- 6 (count str-money)) "0")
                           (vec str-money))))))))
  ([new-money] (set-money @current-state new-money)))
